-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
deferred class PERIODIC_JOB
-- Pseudo periodic job. The timing is not exact : the time between 
-- two execution may be longer than the given period depending on 
-- time needed to execute ready tasks. There is no try to recover the 
-- time lost each time.

inherit JOB


feature {ANY}
   period: DOUBLE  -- unit is seconds
   next_time: MICROSECOND_TIME
   
feature {LOOP_ITEM}
   prepare(ready: READY_DESCRIPTION) is
      do
	 ready.at(next_time)
      end

   is_ready(ready: READY_DESCRIPTION): BOOLEAN is
      do
	 Result := next_time <= ready.current_time
	 if Result then
	    next_time := ready.current_time + period
	 end
      end

invariant
   period > 0
end
