-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
deferred class ALIGNABLE
   -- Helper class to write alignable variant. See for example LABEL_ALIGNABLE
   -- Alignment is useful only if x_expand_allowed or y_expand_allowed
   -- is `True' and the space given to the object is bigger than it's 
   -- standard size.

inherit WIDGET

feature {ANY}
   alignment: ALIGNMENT

   set_alignment(a: ALIGNMENT) is
      -- x_expand_allowed and y_expand_allowed are set to `True' if 
      -- previous alignment was `Void'
      do
	 if alignment = Void then
	    set_x_expand(True)
	    set_y_expand(True)
	 end
	 alignment := a
      end

feature {}
   adjust_pos is
      do
	 if alignment /= Void then
	    pos_x := pos_x+((width-std_width)*alignment.x).truncated_to_integer
	    pos_y := pos_y+((height-std_height)*alignment.y).truncated_to_integer
	 end
      end

end
