-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class BUTTON

inherit
   GRAPHIC
   WHEN_DOUBLE_CLICKED
   WHEN_MIDDLE_CLICKED
   WHEN_RIGHT_CLICKED
   SUB_WINDOW redefine make, set_state, update_decoration end

create make, with_label

feature {}

   make(p: like parent) is
      do
	 precursor(p)

         when_double_clicked_init
	 when_middle_clicked_init
	 when_right_clicked_init

	 set_state_normal
	 map
      end

   with_label(p: like parent; text: UNICODE_STRING) is
      local
	 tmp: LABEL
	 lo: ROW_LAYOUT
      do
	 make(p)
	 create tmp.make(text)
	 --tmp.set_alignment(center_alignment)
	 child_attach(tmp)
	 lo ?= layout
	 lo.set_border(5)
	 lo.set_spacing(5)
      end

feature {ANY}
   set_state(n: INTEGER) is
      do
	 if state /= n then
	    state := n
	    renderer.draw_button(Current)
	    clear_area(0, 0, width, height)
	 end
      end

   update_decoration is
      do
	 renderer.draw_button(Current)
      end


-- border: BORDER

--   set_border(b: like border) is
--      do
--         if border /= Void then
--            layer_remove_child(1, border)
--         end
--         border := b
--         if b /= Void then
--            layer_add_child(1, b)
--         end
--      end


end
