-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class REPEAT_JOB

inherit
   GRAPHIC
   PERIODIC_JOB

creation {WHEN_LEFT_CLICKED}
   make

feature {}

   make is
      do
         period := 0.05
      end

feature {WHEN_LEFT_CLICKED}

   start(target: like clickable) is
      require
         target /= Void
      do
         done := False
         clickable := target
         next_time.update
         next_time := next_time + 0.8
         period := 0.25
         priority := 1
         vision.loop_stack.add_job(Current)
      end

   stop is
      do
         done := True
      end

feature {LOOP_ITEM}

   continue is
      do
         if clickable.left_is_down then
            clickable.left_click_signal.emit
            if period > 0.05 then
               period := period * 0.8
            end
         end
      end

   done: BOOLEAN

feature {}

   clickable: WHEN_LEFT_CLICKED

end
