expanded class POINT

inherit
   ANY
      redefine
         is_equal, out
      end
   HASHABLE

create default_create

feature {ANY}

   default_create is
      do
         --io.put_string(once "new POINT!%N")
      end

   is_equal(other: like Current): BOOLEAN is
      do
         Result := other.x = x
         and then other.y = y
      end

   out: STRING is
      do
         Result := out_buffer
         Result.clear
         Result.extend('(')
         x.append_in(Result)
         Result.extend(',')
         y.append_in(Result)
         Result.extend(')')
      end

feature {DICTIONARY}

   hash_code: INTEGER is
      do
         Result := x * 65536 + y
      end

feature {DECORATOR, POINT}

   set(x_, y_: INTEGER) is
      do
         if not storage.is_not_null then
            make_storage
         end
         basic_guikit_point(to_external, x_, y_);
      end

   set_x(x_: INTEGER) is
      do
         set(x_, y)
      end

   set_y(y_: INTEGER) is
      do
         set(x, y_)
      end

   to_external: POINTER is
      do
         Result := storage.to_external
      end

   x: INTEGER is
      do
         Result := basic_guikit_point_get_x(storage.to_external)
      end

   y: INTEGER is
      do
         Result := basic_guikit_point_get_y(storage.to_external)
      end

feature {DECORATOR}

   export_data(store: like storage; index: INTEGER) is
      do
         store.copy_at(basic_guikit_point_size * index, storage, basic_guikit_point_size)
      end

feature {}

   out_buffer: STRING is "(0,0)"

   storage: NATIVE_ARRAY[BIT 8]

   make_storage is
      do
         storage := storage.calloc(basic_guikit_point_size)
      end

   basic_guikit_point(store: POINTER; x_, y_: INTEGER) is
      external "SmartEiffel"
      end

   basic_guikit_point_size: INTEGER is
      external "SmartEiffel"
      end

   basic_guikit_point_get_x(store: POINTER): INTEGER is
      external "SmartEiffel"
      end

   basic_guikit_point_get_y(store: POINTER): INTEGER is
      external "SmartEiffel"
      end

end -- POINT
