-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class WHEN_LEFT_CLICKED
   inherit
      POINTER_STATUS
      WHEN_LEFT_DOWN
      WHEN_LEFT_UP
      STATE --TODO: should set_state_* function really be used here?

feature {ANY}

   left_click_signal: SIGNAL_0

   when_left_clicked(p: PROCEDURE[ANY,TUPLE]) is
      do
         left_click_signal.connect(p)
      end

   left_is_down: BOOLEAN

feature {}
   when_left_clicked_init is
      do
	 pointer_status_init
	 create left_click_signal.make
         when_left_down(agent private_left_down)
         when_left_up(agent private_left_up)
         when_pointer_enter(agent private_left_pointer_enter)
         when_pointer_leave(agent private_left_pointer_leave)
      end

   left_may_click: BOOLEAN

   private_left_down is
      do
         left_is_down := True
	 left_may_click := True
	 set_state_active
         --paint(pos_x,pos_y)
      ensure
         left_is_down
      end

   private_left_up is
      require
         left_is_down
      do
	 if is_pointer_inside then
	    set_state_prelight
	    if left_may_click then
	       left_click_signal.emit
	    end
         end
         left_is_down := False
	 left_may_click := False
      ensure
         not left_is_down
      end

   private_left_pointer_enter is
      do
	 left_is_down := vision.is_left_down
	 if left_may_click then
	    set_state_active
	 else
	    set_state_prelight
	 end
      end

   private_left_pointer_leave is
      do
	 set_state_normal
      end



end
