-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class WHEN_RIGHT_CLICKED
   inherit
      POINTER_STATUS
      WHEN_RIGHT_DOWN
      WHEN_RIGHT_UP

feature {ANY}
   
   right_click_signal: SIGNAL_0

   when_right_clicked(p: PROCEDURE[ANY,TUPLE]) is
      do
         right_click_signal.connect(p)
      end

   right_is_down: BOOLEAN

feature {}
   when_right_clicked_init is
      do
	 pointer_status_init
	 create right_click_signal.make
         when_right_down(agent private_right_down)
         when_right_up(agent private_right_up)
         when_pointer_enter(agent private_right_pointer_enter)
      end

   right_may_click: BOOLEAN

   private_right_down is
      do
         right_is_down := True
	 right_may_click := True
         --paint(pos_x,pos_y)
      ensure
         right_is_down
      end

   private_right_up is
      require
         right_is_down
      do
	 if right_may_click and then is_pointer_inside then
	    right_click_signal.emit
         end
         right_is_down := False
	 right_may_click := False
      ensure
         not right_is_down
      end

   private_right_pointer_enter is
      do
	 right_is_down := vision.is_right_down
      end


end
