-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class GRAPHIC_CONNECTION
   -- This internal class allow to see the graphic connection as a 
   -- file who the sequencer has to wait data from.
   -- Some graphic program may wait data from multiple source (files) 
   -- and wait for user requests (from the user interface) at the same time.
   -- See lib/sequencer for more details.
  
inherit INPUT_WATCHED_FILE
      export
	 {ANY} is_equal, standard_is_equal, is_connected; 
	 {INPUT_WATCHED_FILE} all
      redefine
	 descriptor, is_connected
      end
   
create {VISION} set_descriptor

feature {}
   set_descriptor(desc: INTEGER) is
      do
	 descriptor := desc
	 if descriptor /= 0 then
	    path := once ""
	 else
	    path := Void
	 end
      end

feature {LOOP_ITEM}
   descriptor: INTEGER

feature {LOOP_ITEM, INPUT_WATCHED_FILE}
   is_connected: BOOLEAN is
      do
	 Result := descriptor /= 0
      end

end
