-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class HORIZONTAL_LINE
   -- `HORIZONTAL_LINE' is a widget you can use as separator. As it's
   -- a widget, position and size are managed by the layout
   -- associated with the container the line is put into.

inherit LINE
      redefine expose_paint
      end
   
create {ANY}
   default_create

feature {}
   default_create is
      do
	 width := 1
	 height := 1
	 thickness := 1
	 x_expand_allowed := True
	 std_width := 1
      end

feature {ANY}
   min_width: INTEGER is 1 --TODO: change with thickness ?
   std_width: INTEGER

   std_height, min_height: INTEGER is
      do
	 Result := thickness
      end

   set_thickness(thick: INTEGER) is
      do
	 --TODO: influence width/position
	 if thickness /= thick then
	    thickness := thick
	    if thick > height then --TODO: change this code
	       height := thick
	    end
	    parent.child_requisition_changed
	 end
      end

feature {LAYOUT}
   expose_paint is
      do
	 if style /= Void then
	    style.draw_line(parent.drawing_widget, pos_x, pos_y,
			    pos_x+width-1, pos_y)
	 else
	    renderer.draw_line(parent, pos_x, pos_y, pos_x+width-1,pos_y,state)
	 end
      end

end
