-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
deferred class LAYOUT
-- A LAYOUT is an algorithm that organise WIDGETs in a CONTAINER.

feature {}
   default_create is
      deferred
      ensure
	 container = Void
      end

feature {ANY}
   container: CONTAINER

feature {CONTAINER}
   set_container(c: CONTAINER) is
      require
	 container = Void
	 c /= Void
	 c.layout = Current
      do
	 container := c
      ensure
	 container = c
      end
   
   detach is
      require
	 container /= Void
      do
	 container := Void
      ensure
	 container = Void
      end

   redo_layout(x, y: INTEGER) is
      require
	 container /= Void
      deferred
      ensure
	 valid_size(container)
      end

   update_requisition is
      require
	 container /= Void
      deferred
      end

   expose_paint is
      require
	 container /= Void
      deferred
      end

   valid_size(c: CONTAINER): BOOLEAN is
      local
	 i: INTEGER
	 child: FIXED_ARRAY[WIDGET]
	 w: WIDGET
      do
	 from
	    Result := True
	    child := c.child
	    i := child.upper
	 until
	    i < child.lower or Result = False
	 loop
	    w := child.item(i)
	    Result := w.valid_width(w.width) and w.valid_height(w.height)
	    i := i - 1
	 end
      end

	 
end
