-- This file is  free  software, which  comes  along  with  SmartEiffel. This
-- software  is  distributed  in the hope that it will be useful, but WITHOUT
-- ANY  WARRANTY;  without  even  the  implied warranty of MERCHANTABILITY or
-- FITNESS  FOR A PARTICULAR PURPOSE. You can modify it as you want, provided
-- this header is kept unaltered, and a notification of the changes is added.
-- You  are  allowed  to  redistribute  it and sell it, alone or as a part of
-- another product.
--       Copyright (C) 1994-2002 LORIA - INRIA - U.H.P. Nancy 1 - FRANCE
--          Philippe RIBET and Dominique COLNET - SmartEiffel@loria.fr
--                       http://SmartEiffel.loria.fr
--
class RECTANGLE
   -- Use rectangle as widget (insert in container then position, draw 
   -- and size are automatic).

inherit
   WIDGET
   DRAWABLE_HANDLER
   GRAPHIC --TODO: supress ?

create {ANY}
   make

feature {}
   make(min_w, min_h, std_w, std_h: INTEGER) is
      do
	 min_width := min_w
	 min_height := min_h
	 std_width := std_w
	 std_height := std_h
	 width := std_w
	 height := std_h
	 x_expand_allowed := True
	 y_expand_allowed := True
      end

feature {ANY}
   min_width, min_height: INTEGER
   std_width, std_height: INTEGER
   width, height: INTEGER

   style: DRAW_STYLE

   set_style(s: DRAW_STYLE) is
	 -- Change the style used to draw the rectangle.
	 -- NOTE: The screen is not updated. --TODO: change this ?
      require
	 s /= Void
      do
	 style := s
      end

   reset_default_style is
	 -- The renderer will be used to draw the line.
	 -- NOTE: The screen is not updated. --TODO: change this ?
      do
	 style := Void
      end

feature {LAYOUT}
   expose_paint is
      do
	 --TODO: handle the width
	 if style /= Void then
	    style.draw_rectangle(parent.drawing_widget, pos_x, pos_y,
				 width, height)
	 else
	    renderer.draw_rectangle(parent, pos_x, pos_y, width, height, state)
	 end
      end

   set_geometry(x, y, w, h: INTEGER) is
      do
	 pos_x := x
	 pos_y := y
	 width := w
	 height := h
      end

feature {}
   resize(w, h: INTEGER) is
      do
	 width := w
	 height := h
      end

end
