class HEXA_TO_UTF8
-- This tool allow to encode Hexa value (http://www.unicode.org/charts/)
-- to utf8 sequence (for manifest unicode strings).

create
   make

feature {}
   make is
      local
	 i: INTEGER
      do
	 create us.make(1)
	 if argument_count > 0 then
	    from
	       i := 1
	    until
	       i > argument_count
	    loop
	       convert(argument(i))
	       i := i + 1
	    end
	 else
	    io.put_string("Write %"end%" or %"quit%" when finished.%N")
	    from
	       io.read_line
	    until
	       io.last_string.is_equal(once "end") or 
		  io.last_string.is_equal(once "quit")
	    loop
	       convert(io.last_string)
	       io.read_line
	    end
	 end
      end

   us: UNICODE_STRING
   
   convert(s: STRING) is
      local
	 v: INTEGER -- Value given in `s'
	 i: INTEGER
	 error: BOOLEAN
	 conv: STRING
      do
	 conv := once ""
	 conv.clear
	 us.clear
	 from
	    i := 1
	 until
	    i > s.count or else error
	 loop
	    if s.item(i).is_hexadecimal_digit then
	       v := v * 16 + s.item(i).hexadecimal_value
	    else
	       io.put_string(s)
	       io.put_string(" is not valid hexadecimal value.%N")
	       from
	       until
		  i <= 1
	       loop
		  io.put_character(' ')
		  i := i - 1
	       end
	       io.put_string("^%NBad character.")
	    end
	    i := i + 1
	 end
	 if not error then
	    if not us.valid_unicode(v) then
	       io.put_string("Value " + v.to_string + " is not valid.%N")
	    else
	       us.add_last(v)
	       us.utf8_encode_in(conv)
	       io.put_character('"')
	       io.put_string(conv)
	       io.put_string(once "%" utf8 sequence: ")
	       from
		  i := 1
	       until
		  i > conv.count
	       loop
		  io.put_string(once "%%/")
		  io.put_integer(conv.item(i).code)
		  io.put_character('/')
		  i := i + 1
	       end
	       io.put_new_line
	    end
	 end
      end

end
